/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (3.1.2).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package org.openapitools.v1_0.api;

import org.openapitools.v1_0.model.Error;
import org.openapitools.v1_0.model.ExtendedNotebook;
import org.openapitools.v1_0.model.Notebook;
import org.openapitools.v1_0.model.Snapshot;
import org.openapitools.v1_0.model.SnapshotURL;
import io.swagger.annotations.*;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;
import java.util.Optional;
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2023-09-15T12:23:18.056Z[GMT]")

@Validated
@Api(value = "notebook", description = "the notebook API")
public interface NotebookApi {

    default Optional<NativeWebRequest> getRequest() {
        return Optional.empty();
    }

    @ApiOperation(value = "Deploys a notebook and creates a data and working directory.", nickname = "createNotebook", notes = "Deploys a notebook and creates a data directory that is read-only from the prespective of the notebook, but that can be written to by submitting workflow jobs through the /workflow/_* API endpoints. A working directory that can be written to from the notebook is also created.", response = Notebook.class, tags={ "notebook", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success", response = Notebook.class),
        @ApiResponse(code = 400, message = "Bad request", response = Error.class),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/notebook",
        produces = { "application/json" }, 
        consumes = { "application/json", "application/xml" },
        method = RequestMethod.POST)
    @CrossOrigin
    default ResponseEntity<?> createNotebook(@ApiParam(value = "Jupyter notebook"  )  @Valid @RequestBody Notebook notebook) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    ApiUtil.setExampleResponse(request, "application/json", "null");
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Deletes notebook for the given notebookId.", nickname = "deleteNotebook", notes = "Deletes notebook for given notebook-Id. Related jobs and workflows are also deleted. If a job is still running, deletion of the notebook is aborted.", tags={ "notebook", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success"),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/notebook/{id}",
        produces = { "application/json" }, 
        method = RequestMethod.DELETE)
    default ResponseEntity<?> deleteNotebook(@ApiParam(value = "Id of the running notebook.",required=true) @PathVariable("id") String id) {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Retrieves the running notebook for the given notebookId.", nickname = "getNotebook", notes = "Retrieves the running notebook and its installed libraries for the given notebookId", response = ExtendedNotebook.class, tags={ "notebook", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success", response = ExtendedNotebook.class),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/notebook/{id}",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    @CrossOrigin
    default ResponseEntity<?> getNotebook(@ApiParam(value = "Id of the running notebook.",required=true) @PathVariable("id") String id) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    ApiUtil.setExampleResponse(request, "application/json", "null");
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Restore Notebook libraries from a previous update", nickname = "restoreNotebookLibs", notes = "", response = Notebook.class, tags={ "notebook", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success", response = Notebook.class),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class),
        @ApiResponse(code = 501, message = "Not implemented", response = Error.class) })
    @RequestMapping(value = "/notebook/{id}/restorelibs/{activityId}",
        produces = { "application/json" }, 
        method = RequestMethod.PUT)
    default ResponseEntity<?> restoreNotebookLibs(@ApiParam(value = "",required=true) @PathVariable("id") String id,@ApiParam(value = "Numeric ID of the activity id to restore libraries to",required=true) @PathVariable("activityId") String activityId) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    ApiUtil.setExampleResponse(request, "application/json", "null");
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Creates a notebook snapshot", nickname = "storeSnapshot", notes = "Creates a notebook snapshot.", response = SnapshotURL.class, tags={ "notebook", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success", response = SnapshotURL.class),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class),
        @ApiResponse(code = 501, message = "Not implemented", response = Error.class) })
    @RequestMapping(value = "/notebook/{id}/snapshot",
        produces = { "application/json" }, 
        consumes = { "application/json", "application/xml" },
        method = RequestMethod.POST)
    default ResponseEntity<?> storeSnapshot(@ApiParam(value = "",required=true) @PathVariable("id") String id,@ApiParam(value = "Snapshot"  )  @Valid @RequestBody Snapshot snapshot) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    ApiUtil.setExampleResponse(request, "application/json", "{  \"snapshotURL\" : \"www.gitlab.com\"}");
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    @ApiOperation(value = "Update Notebook libraries", nickname = "updateNotebook", notes = "", response = Notebook.class, tags={ "notebook", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Success", response = Notebook.class),
        @ApiResponse(code = 404, message = "Not found", response = Error.class),
        @ApiResponse(code = 405, message = "Invalid input", response = Error.class),
        @ApiResponse(code = 500, message = "Internal server error", response = Error.class) })
    @RequestMapping(value = "/notebook/{id}",
        produces = { "application/json" }, 
        consumes = { "application/json", "application/xml" },
        method = RequestMethod.PUT)
    default ResponseEntity<?> updateNotebook(@ApiParam(value = "Numeric ID of the notebook to update libraries",required=true) @PathVariable("id") String id,@ApiParam(value = "Jupyter notebook"  )  @Valid @RequestBody Notebook notebook) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    ApiUtil.setExampleResponse(request, "application/json", "null");
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }

}
